
public class TripleCalculator {
	private int x; // first number
	private int y; // second number
	private int z; // third number
	private Operator op = Operator.MIN; // operator
	private double w; // result 
	
	public TripleCalculator() {
		this(0, 0, 0);
	}
	
	public TripleCalculator(int x, int y, int z) {
		this(x, y, z, Operator.MIN);
	}
	
	public TripleCalculator(int x, int y, int z, Operator op) {
		set(x, y, z, op);
	}
	
	public void set(int x, int y, int z, Operator op) {
		this.x = x;
		this.y = y;
		this.z = z;
		this.op = op;
		this.w = calculate(x, y, z, op);
	}
		
	public int getX() {
		return x;
	}
	
	public int getY() {
		return y;
	}

	public int getZ() {
		return z;
	}
	
	public double getW() {
		return w;
	}

	@Override // toString method override of Object class
	public String toString() { 
		return this.op + "(" + this.x + "," + this.y + "," + this.z + ")=" +  this.w;
	}
	
	public static double calculate(int x, int y, int z, Operator op) {
		switch(op) {
		case MIN: 
			return min(x, y, z);
		case MAX: 
			return max(x, y, z);
		case MEDIAN: 
			return median(x, y, z);
		case MEAN: 
			return mean(x, y, z);
		case SUM:
			return sum(x, y, z);
		default:
			System.out.println("op not found");
			return 0;
		}
	}
	
	public static int min(int x, int y, int z) {
		return Math.min(Math.min(x, y), z);
	}
	
	public static int max(int x, int y, int z) {
		return Math.max(Math.max(x, y), z);
	}
	
	public static int median(int x, int y, int z) {
		return Math.max(Math.min(x,y), Math.min(Math.max(x,y),z));
	}	
	
	public static double mean(int x, int y, int z) {
		return (x + y + z) / 3.0;
	}
	
	public static int sum(int x, int y, int z) {
		return x + y + z;
	}
		
	public static int product(int x, int y, int z) {
		return x * y * z;
	}
}
