import java.util.Scanner;

//2. UserInput
public class UserInput {
	
	// user input
	private static Scanner scan = new Scanner(System.in);

	private UserInput() {}

	// get string
	public static String getString(String description)	{
		System.out.print(description);
		String line = scan.nextLine();
		return line;
	}
	
	// get char op [+,-,*,/]
	public static Operator getOperator(String description) {
		int value = getIntegerBetween(description, 1, 5);
		switch (value) { // switch
		case 1:
			return Operator.MIN;
		case 2:
			return Operator.MAX;
		case 3:
			return Operator.MEDIAN;
		case 4:
			return Operator.MEAN;
		case 5:
			return Operator.SUM;
		default:
			System.out.println("Error! cannot found this operator");
			return null;
		}		
	}
	
	// get int using try/catch
	public static int getInteger(String description) {
		System.out.print(description);
		int value;
		while(true) {
			String line = scan.nextLine();
			try {
				value = Integer.parseInt(line);
				break;
			}
			catch (Exception e) {
				System.out.print("Error! Please enter [int value]: ");
			}
		}
		return value;
	}

	// get double using try/catch
	public static double getDouble(String description) {
		System.out.print(description);
		 double value;
		 while(true) {
			 try {
				 value = scan.nextDouble();
				 break;
			 }
			 catch (Exception e) {
				 System.out.print("Error! Please re-enter [double value]: ");
				 scan.next();
			 }
		 }
		 return value;
	}
	
	// get int using try/catch
	public static int getIntegerBetween(String description, int min, int max) {
		int value = 0;
		do {
			System.out.print(description);
			String line = scan.nextLine();
			try {
				value = Integer.parseInt(line);
			}
			catch (Exception e) {
				System.out.printf("Error! Please re-enter");
				continue;
			}
		} while(value < min || value > max);
		return value;
	}

	public static boolean getExitKey() {
		System.out.print("Press q-key to exit the program or enter-key to start the program: ");
		String line = scan.nextLine();
        if (line.contentEquals("q"))
            return true;
        else
        	return false;
	}

	public static TripleCalculator getTripleCalculator() {
		System.out.println("Triple calculator using user input");
		int x = UserInput.getInteger("Please enter the first number: ");
		int y = UserInput.getInteger("Please enter the second number: ");
		int z = UserInput.getInteger("Please enter the third number: ");
		Operator op = UserInput.getOperator("Please enter the operator [1.MIN, 2.MAX, 3.MEDIAN, 4.MEAN, 5.SUM]: ");
		return new TripleCalculator(x, y, z, op);
	}
}
